/**
 * Objektum letrehozas/megszuntetes demo
 * Forditas:
 *    g++ -o valami valami.cpp
 * ahhoz, hogy a for is menjen:
 *    g++ -D_FOR -o valami valami.cpp
 * Futattas:
 *    ./valami
 *
 */

#include <iostream>

using std::cout;
using std::endl;

struct Valami {
    Valami()  { cout << "HAHO megszulettem!" << endl; }
    ~Valami() { cout << "JAJ, vegem van!" << endl; }
};

int main() {
    int db = 0;
    cout << ++db << ". ";
    Valami o1;
    cout << ++db << ". ";
    Valami o2;

    cout << ++db << ". (new) ";
    Valami *o3 = new Valami;
    cout << "   (delete) ";
    delete o3;

    cout << "--- blokk elott: ---\n";
    {
         cout << ++db << ". ";
         Valami o1;
    }
    cout << "--- blok utan: ---\n";



#ifdef _FOR
    cout << "--- For indul ---" << endl;
    for (int i = 0; i < 5; i++) {
       cout << ++db << ". ";
       Valami o1;
    }
    cout << "--- Vege ----" << endl;
#endif // _FOR
    return 0;
}


